//
// Added 3/19/2015 12:31:13 PM
// This magic object handles the three LED digits that display the 32bit number as an unsigned decimal.
func rMagicObject0(var action, var object, var newVal, var *ptr)
    var p1, p2, i ,j;
    var bytes[4], buffer[15], chars[11];
    var char;
    var value0 := 0, value1 := 0, value2 := 0;
    var m;
    if (action != WRITE_MAGIC_BYTES || newVal != 4) goto exit;  // check command and number of bytes

    // arrange the received bytes
    bytes[1] := ptr[0] << 8 + ptr[1];
    bytes[0] := ptr[2] << 8 + ptr[3];

    gfx_MoveTo(0,88);                       // move the cursor to a specific location
    txt_FGcolour(LIME);                     // set text foreground color
    print("received: ", [HEX2]ptr[0]," ",[HEX2]ptr[1]," ",[HEX2]ptr[2]," ",[HEX2]ptr[3],"    ");

    p1 := str_Ptr(bytes);
    str_Printf(&p1, "%010lu\n");            // print to display, unsigned long decimal format
    p1 := str_Ptr(bytes);
    to(buffer); str_Printf(&p1, "%010lu");  // stream to a working buffer
    p2 := str_Ptr(buffer);

    i := 0;
    while(str_GetC(&p2, &chars[i])) i++;    // "extract" the ASCII characters from the string in the buffer

    for(i := 0; i < 10; i++)                // convert the ASCII characters to integers
        chars[i] -= 0x30;
    next

    for(i := 0; i < 4; i++)                 // get the value of the first four least significant digits
        m := 1;
        for(j := 0; j < i; j++) m *= 10;
        value0 += chars[9-i] * m;
    next

    for(i := 0; i < 4; i++)                 // get the value of the second four least significant digits
        m := 1;
        for(j := 0; j < i; j++) m *= 10;
        value1 += chars[5-i] * m;
    next

    for(i := 0; i < 2; i++)                 // get the value of the two most significant digits
        m := 1;
        for(j := 0; j < i; j++) m *= 10;
        value2 += chars[1-i] * m;
    next

    WriteObject(tLeddigits, 0, value0) ;    // write the computed values to the appropriate LED digits
    WriteObject(tLeddigits, 1, value1) ;
    WriteObject(tLeddigits, 2, value2) ;

exit:
    seroutX(ACK) ;
endfunc

