//
// Added 3/19/2015 12:31:13 PM
// This magic object handles the three LED digits that display the 32bit number as signed decimal.
func rMagicObject1(var action, var object, var newVal, var *ptr)
    var p1, p2, i ,j;
    var bytes[4], buffer[15], chars[11];
    var char;
    var value0 := 0, value1 := 0, value2 := 0;
    var m;
    if (action != WRITE_MAGIC_BYTES || newVal != 4) goto exit;

    bytes[1] := ptr[0] << 8 + ptr[1];
    bytes[0] := ptr[2] << 8 + ptr[3];

    gfx_MoveTo(0,180);
    txt_FGcolour(YELLOW);
    print("received: ", [HEX2]ptr[0]," ",[HEX2]ptr[1]," ",[HEX2]ptr[2]," ",[HEX2]ptr[3],"    ");

    p1 := str_Ptr(bytes);
    str_Printf(&p1, "%010ld   ");           // print to display, signed long decimal format
    p1 := str_Ptr(bytes);
    to(buffer); str_Printf(&p1, "%010ld");  // stream to a working buffer
    p2 := str_Ptr(buffer);

    i := 0;
    while(str_GetC(&p2, &chars[i])) i++;

    for(i := 1; i < 11; i++)
        chars[i] -= 0x30;
    next

    for(i := 0; i < 4; i++)
        m := 1;
        for(j := 0; j < i; j++) m *= 10;
        value0 += chars[10-i] * m;
    next

    for(i := 0; i < 4; i++)
        m := 1;
        for(j := 0; j < i; j++) m *= 10;
        value1 += chars[6-i] * m;
    next

    for(i := 0; i < 2; i++)
        m := 1;
        for(j := 0; j < i; j++) m *= 10;
        value2 += chars[2-i] * m;
    next

    if(bytes[1] < 0)                          // check if negative
        WriteObject(tUserled, 0, 0x01);       // turn on the user LED (negative symbol)
    else
        WriteObject(tUserled, 0, 0x00);       // turn off the user LED
        //WriteObject(tUserled, 0, 0xFFFF);   // or you can make the user LED 'disappear'
    endif

    WriteObject(tLeddigits, 3, value0) ;
    WriteObject(tLeddigits, 4, value1) ;
    WriteObject(tLeddigits, 5, value2) ;

exit:
    seroutX(ACK) ;
endfunc
